#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;

struct Query
{
    int type,x,y;
};

int n,q;
long long a[MAXN];
Query qr[MAXN];
int dv[MAXN];
vector<pair<pair<int,int>,int> > v;
long long pref[MAXN];

int bsl(int x)
{
    int l=0, r=v.size()-1;
    while(l<r)
    {
        int mid=(l+r)/2;
        if(v[mid].fi.fi<x) l=mid+1;
        else r=mid;
    }
    return l;
}

int bsr(int x)
{//cout<<x<<endl;
    int l=0,r=v.size()-1;
    while(l<r)
    {
        int mid=(l+r+1)/2;
        if(v[mid].fi.se<=x) l=mid;
        else r=mid-1;
    }
    return r;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>q;
for(int i=0;i<q;i++)
{
    cin>>qr[i].type>>qr[i].x;
    if(qr[i].type==1) dv[qr[i].x+1]++;
    else if(qr[i].type==2) dv[qr[i].x+1]--;
    else if(qr[i].type==3)
    {
        cin>>qr[i].y;
        a[qr[i].x]+=qr[i].y;
    }
    else cin>>qr[i].y;
}

dv[n+1]=1;
for(int i=1;i<=n;i++) dv[i]=dv[i]%2;

for(int i=1;i<=n;i++)
{
    if(dv[i])
    {
        long long mx=a[i];
        int l=i;
        for(int j=i+1;;j++)
        {
            if(dv[j]) {i=j+1; break;}
            mx=max(mx,a[j]);
        }
        int r=i-2;
        v.push_back({{l,r},mx});
    }
}

//for(int i=0;i<v.size();i++) cout<<v[i].fi.fi<<" "<<v[i].fi.se<<" "<<v[i].se<<endl;

pref[0]=v[0].se;
for(int i=1;i<v.size();i++) pref[i]=pref[i-1]+v[i].se;

for(int i=0;i<q;i++)
{
    if(qr[i].type!=4) continue;
    int l=bsl(qr[i].x);
    int r=bsr(qr[i].y);
    //cout<<l<<" "<<r<<endl;
    long long ans=0;
    if(l>0)
    {
        long long mx=0;
        for(int j=qr[i].x;j<=v[l-1].fi.se;j++) mx=max(mx,a[j]);
        ans+=mx;
    }
    if(r<v.size()-1)
    {
        long long mx=0;
        for(int j=v[r+1].fi.fi;j<=qr[i].y;j++) mx=max(mx,a[j]);
        ans+=mx;
    }
    if(l<=r) ans+=pref[r]-(l>0 ? pref[l-1] : 0);
    cout<<ans<<endl;
}

return 0;
}
/*
10 20
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 3 6
1 1
4 3 6
3 10 3
3 9 2
3 8 9
1 8
4 1 10
4 4 9
3 9 8
1 7
3 2 6
4 2 9
2 1
4 2 9

10 11
1 4
3 3 7
3 4 1
3 5 8
3 6 5
1 1
3 10 3
3 9 2
3 8 9
1 8
4 1 10
*/
