#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const long long maxn = 1e5+10;

vector<long long> dif;
long long a[maxn];

long long tree[4*maxn];

void update(long long vr, long long l, long long r,long long x, long long val)
{
    if(l==r)
    {
        tree[vr]+=val;
        return;
    }
    long long mid = (l+r)>>1;
    if(x<=mid)update(2*vr,l,mid,x,val);
    else update(2*vr+1,mid+1,r,x,val);
    tree[vr]=tree[2*vr]+tree[2*vr+1];
}

long long query(long long vr, long long l, long long r, long long L, long long R)
{
    if(R<l||L>r)return 0;
    if(L<=l&&R>=r)return tree[vr];
    long long mid=(l+r)>>1;
    return query(2*vr,l,mid,L,R)+query(2*vr+1,mid+1,r,L,R);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n,q;
    cin>>n>>q;

    for(long long i=0; i<q; i++)
    {
        long long k;
        cin>>k;
        if(k==1)
        {
            long long p;
            cin>>p;
            update(1,1,n,p+1,1);
        }
        else if(k==2)
        {
            long long p;
            cin>>p;
            update(1,1,n,p+1,-1);
        }
        else if(k==3)
        {
            long long p,d;
            cin>>p>>d;
            a[p]+=d;
        }
        else if(k==4)
        {
            long long l,r;
            cin>>l>>r;
            if(query(1,1,n,1,l)%2)cout<<a[l]<<endl;
            else cout<<0<<endl;
        }
        /*for(long long i=0;i<dif.size();i++)
        {
            cout<<dif[i]<<" ";
        }
        cout<<endl;*/
    }

    return 0;
}
/**
10 20
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 3 3
1 1
4 3 3
3 10 3
3 9 2
3 8 9
1 8
4 1 1
4 4 4
3 9 8
1 7
3 2 6
4 2 2
2 1
4 2 2
*/
