#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const long long maxn = 1e5+10;

long long d[maxn];
long long pos[maxn];
long long a[maxn];
long long tree[4*maxn];
long long oddTree[4*maxn];
long long st[maxn];
long long en[maxn];
long long maxp[maxn];
long long query(long long vr, long long l, long long r, long long L, long long R)
{
    if(L>r||R<l)return 0;
    if(l>=L&&r<=R)return tree[vr];
    long long mid = (l+r)>>1;
    return max(query(2*vr,l,mid,L,R),query(2*vr+1,mid+1,r,L,R));
}
long long query2(long long vr, long long l, long long r, long long L, long long R)
{
    if(L>r||R<l)return 0;
    if(l>=L&&r<=R)return oddTree[vr];
    long long mid = (l+r)>>1;
    return query2(2*vr,l,mid,L,R)+query2(2*vr+1,mid+1,r,L,R);
}

void build(long long vr, long long l, long long r)
{
    if(l==r)
    {
        tree[vr]=a[l];
        return;
    }
    long long mid=(l+r)>>1;
    build(2*vr,l,mid);
    build(2*vr+1,mid+1,r);
    tree[vr]=max(tree[2*vr],tree[2*vr+1]);
}
void build2(long long vr, long long l, long long r)
{
    if(l==r)
    {
        if(l%2)oddTree[vr]=maxp[l];
        return;
    }
    long long mid=(l+r)>>1;
    build2(2*vr,l,mid);
    build2(2*vr+1,mid+1,r);
    oddTree[vr]=oddTree[2*vr]+oddTree[2*vr+1];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n,q;
    cin>>n>>q;
    bool t=0;
    long long k=0;
    for(long long i=0;i<q;i++)
    {

        long long type;
        cin>>type;
        if(type==1||type==2)
        {
            long long p;
            cin>>p;
            d[p]^=1;
        }
        else if(type==3)
        {
            long long p,c;
            cin>>p>>c;
            a[p]+=c;
        }
        else if(type==4)
        {
            if(t==0)
            {
                build(1,1,n);
                for(long long i=1;i<=n;i++)
                {
                    pos[i]=k;
                    maxp[k]=max(maxp[k],a[i]);
                    if (d[i])
                    {
                        en[k++]=i;
                        st[k]=i+1;
                    }
                }
                en[k]=n;
                build2(1,1,k);
                t=1;
            }
            long long l,r;
            cin>>l>>r;
            long long ans=0;
            if(pos[l]==pos[r]&&pos[l]%2)
            {
                cout<<query(1,1,n,l,r)<<endl;
                continue;
            }
            if(pos[l]%2)ans+=query(1,1,n,l,en[pos[l]]);
            if(pos[r]%2)ans+=query(1,1,n,st[pos[r]],r);
            if(pos[l]<pos[r]-1)ans+=query2(1,1,k,pos[l]+1,pos[r]-1);
            //cout<<pos[l]+1<<" "<<pos[r]-1<<endl;
            cout<<ans<<endl;
        }
       /* cout<<endl;
       for(long long i=0;i<4*n;i++)
        {
            cout<<oddTree[i]<<" ";
        }
        cout<<endl;*/
    }

    return 0;
}
/**
10 20
1 4
3 3 7
3 4 1
3 5 8
3 6 5
1 1
3 10 3
3 9 2
3 8 9
1 8
3 9 8
1 7
3 2 6
2 1
4 3 4
4 3 6
4 1 10
4 4 9
4 2 9
4 2 9

*/
