#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
}

struct point
{
    int x, y;
};

const int maxn = 2e5 + 10;

point car[maxn];

struct event
{
    int x, y1, y2;

    event(int _x = 0 , int _y1 = 0, int _y2 = 0)
    {
        x = _x;
        y1 = _y1;
        y2 = _y2;
        if (y1 > y2)
            swap(y1, y2);
        y2 --;
    }
};

bool cmp(event e1, event e2)
{
    if (e1.x != e2.x)
        return e1.x < e2.x;
    return e1.y1 < e2.y1;
}

int n, m;
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        cin >> car[i].x >> car[i].y;
}

struct interval
{
    int left, right, start;

    interval(int _left = 0, int _right = 0, int _start = 0)
    {
        left = _left;
        right = _right;
        start = _start;
    }

    bool operator < (const interval &it) const
    {
        if (left != it.left)
            return left < it.left;
        if (right != it.right)
            return right < it.right;
        return start < it.start;
    }
};

set < interval > act;
void simulate()
{
    vector < event > events;
    for (int i = 1; i < n; i ++)
    {
        if (car[i].x == car[i + 1].x && car[i + 1].y != car[i].y)
        {
            events.push_back(event(car[i].x, car[i].y, car[i + 1].y));
        }
    }
    if (car[n].x == car[1].x && car[n].y != car[1].y)
        events.push_back(event(car[n].x, car[1].y, car[n].y));

    sort(events.begin(), events.end(), cmp);

    int ans = 0;
    bool done = false;
    int act_odd = 0, act_even = 0, last = 0;
    set < pair < int, int > > ranges;
    for (int i = 0; i < events.size(); i ++)
    {

        interval cur(events[i].y1, events[i].y2, events[i].x);

        for (interval c : act)
        {
            assert(c.left <= c.right);
        }
        if (cur.start != last && !done)
        {
            ///cout << cur.start << " " << last << endl;
            /**for (interval c : act)
                if ((c.right - c.left + 1) % 2 != 0)
                {
                    done = true;
                    break;
                }
            if (done)
                break;

            bool odd = false, even = false;
            for (interval c : act)
                if (c.start % 2 == 1)
                    odd = true;
                else
                    even = true;*/

            if (act_odd && !act_even)
            {
                if (cur.start % 2 == 1)
                    ans = max(ans, cur.start);
                else
                    ans = max(ans, cur.start - 1);
            }
            else
            if (!act_odd && act_even)
            {
                if (cur.start % 2 == 0)
                    ans = max(ans, cur.start);
                else
                    ans = max(ans, cur.start - 1);
            }
        }
        ///act.insert(cur);
        set < interval > :: iterator it = act.lower_bound(interval(cur.left, cur.left, -1));
        bool add = true;
        if (it != act.end() && it -> left <= cur.right)
            add = false;
        if (it != act.begin() && prev(it) -> right >= cur.left)
            add = false;



        if (!add)
        {
            ///act.erase(cur);
            bool rem = false;
            while(!act.empty())
            {
                set < interval > :: iterator help = act.lower_bound(interval(cur.left, cur.left, -1));

                if (help == act.end() || help -> left > cur.right)
                    break;
                if (help -> right <= cur.right)
                {
                    if (help -> start % 2 == 0)
                        act_even --;
                    else
                        act_odd --;
                    if ((cur.start - help -> start) % 2 != 0)
                        done = true;
                    act.erase(help);
                    rem = true;
                }
                else
                {
                    if ((cur.start - help -> start) % 2 != 0)
                        done = true;
                    interval new_it = *help;
                    act.erase(help);
                    new_it.left = cur.right + 1;
                    act.insert(new_it);
                    rem = true;
                }
            }
            set < interval > :: iterator help = act.lower_bound(interval(cur.left, cur.left, -1));

            if (help != act.begin())
            {
                help = prev(help);

                if (help -> right > cur.right)
                {
                    if (cur.start - (help -> start) % 2 != 0)
                        done = true;
                    interval new_lf(help -> left, cur.left - 1, help -> start);
                    interval new_rf(cur.right + 1, help -> right, help -> start);
                    act.erase(help);
                    act.insert(new_lf);
                    act.insert(new_rf);
                    if (new_lf.start % 2 == 1)
                        act_odd ++;
                    else
                        act_even ++;
                    rem = true;
                }
                else
                if (help -> right >= cur.left)
                {
                    if (cur.start - (help -> start) % 2 != 0)
                        done = true;
                    interval new_bef(help -> left, cur.left - 1, help -> start);
                    act.erase(help);
                    act.insert(new_bef);
                    rem = true;
                }
            }
            assert(rem);
        }
        else
        {
            act.insert(cur);
            if (cur.start % 2 == 1)
                act_odd ++;
            else
                act_even ++;

            ///ranges.insert({cur.left, cur.right});
            ///set < pair < int, int > > :: iterator it :
            /**if (it != act.begin())
            {
                if (prev(it) -> start == it -> start && prev(it) -> right == it -> left - 1)
                {
                    interval comb(prev(it) -> left, it -> right, cur.start);
                    act.erase(prev(it));
                    act.erase(cur);
                    act.insert(comb);
                    it = act.find(comb);
                }
            }
            if (next(it) != act.end())
            {
                if (next(it) -> start == it -> start && next(it) -> left - 1 == it -> right)
                {
                    interval comb(it -> left, next(it) -> right, cur.start);
                    act.erase(next(it));
                    act.erase(cur);
                    act.insert(comb);
                    it = act.find(comb);
                }
            }*/

        }

        last = cur.start;

        /**cout << "-------------" << endl;
        for (interval c : act)
            cout << c.left << " " << c.right << " " << c.start << endl;*/

    }

    cout << ans << endl;

}
void solve()
{
    input();
    simulate();
}

int main()
{
    ///speed();
    solve();
    return 0;
}

/**
14 6
0 1
0 3
2 3
2 4
0 4
0 6
3 6
3 7
4 7
6 7
6 5
3 5
3 2
3 1

4 4
0 1
0 5
5 5
5 1

*/
