#include "zeroes.h"

void set_matrix_mem_column(int l, int sz)
{
    for(int i = 0; i < sz; i++)
        set_mem(l, i, 3);
}

void set_matrix_mem_row(int l, int sz)
{
    for(int i = 0; i < sz; i++)
    {
        set_mem(i, l, 3);
    }
    //set_mem(0, 1, 3);

/*
ANS
1 0 1 1
0 0 0 0
1 0 1 1
1 0 1 1
*/

}

bool solve(int N, int call)
{
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            int current = get_mem(i, j);
            if(current == 0)
            {
                set_matrix_mem_column(i, N);
                set_matrix_mem_row(j, N);
            }
        }
    }
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(get_mem(i, j) > 1)
            {
                set_mem(i, j, 0);
            }
        }
    }

    return true;
}

/*

===================
4
1 1 1 1
1 0 1 1
1 1 1 1
1 1 1 1

ANS
1 0 1 1
0 0 0 0
1 0 1 1
1 0 1 1
====================

====================
4
0 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
====================

4
1 1 1 0
1 1 1 1
1 1 1 1
1 1 1 0

===================
4
1 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
*/
