#include "zeroes.h"

struct res
{
    int a;
    int b;
};

void set_matrix_mem_column(int l, int sz, int k)
{
    for(int i = 0; i < sz; i++)
        set_mem(l, i, k);
}

void set_matrix_mem_row(int l, int sz, int k)
{
    for(int i = 0; i < sz; i++)
    {
        set_mem(i, l, k);
    }
}

bool solve(int N, int call)
{
    res ans[1000];
    for(int i = 0; i < 1000; i++)
    {
        ans[i].a = -1;
        ans[i].b = -1;
    }

    int a[100][100];
    int k = 2;

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            a[i][j] = get_mem(i, j);
        }
    }



    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            int res = get_mem(i, j);
            if(res > 1)
            {
                set_mem(i, j, 1);
            }
        }
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            int current = get_mem(i, j);
            if(current == 0)
            {
                ans[i].a = i;
                ans[i].b = j;
                //b[i] = i;
                //v.push_back({i, j});
            }
        }
    }

    //for(int i = 0; i < v.size(); i++)
    for(int i = 1; i < 1000; i++)
    {
        if(ans[i].a == -1) break;
        k++;
        set_matrix_mem_row(ans[i].b, N, k);
        set_matrix_mem_column(ans[i].a, N, k);
        //set_matrix_mem_row(v[i].second, N, k);
        //set_matrix_mem_column(v[i].first, N, k);
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(get_mem(i, j) > 1)
            {
                set_mem(i, j, 0);
            }
        }
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(get_mem(i, j) > 0)
            {
                set_mem(i, j, a[i][j]);
            }
        }
    }
    return true;
}

/*

===================
4
1 1 1 1
1 0 1 1
1 1 1 1
1 1 1 1

ANS
1 0 1 1
0 0 0 0
1 0 1 1
1 0 1 1
====================

====================
4
0 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
====================

4
1 1 1 0
1 1 1 1
1 1 1 1
1 1 1 0

===================
4
1 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1

====================
3
1 1 1
0 1 1
1 1 0

====================
3
1 2 3
0 4 5
6 7 0
===================
*/
