#include "zeroes.h"
#include<vector>

struct danni
{
    int b[100][100];
};

void set_matrix_mem_column(int l, int sz, int k, danni& x)
{
    for(int i = 0; i < sz; i++)
        x.b[l][i] = k;
}

void set_matrix_mem_row(int l, int sz, int k, danni& x)
{
    for(int i = 0; i < sz; i++)
        x.b[i][l] = k;
}

bool solve(int N, int call)
{
    std::vector<std::pair<int, int>> v;
    int a[100][100];
    danni x;
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            a[i][j] = get_mem(i, j);
            x.b[i][j] = a[i][j];
        }
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            int res = x.b[i][j];
            if(res > 1)
            {
                x.b[i][j] = 1;
            }
        }
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            int current = x.b[i][j];
            if(current == 0)
            {
                v.push_back({i, j});
            }
        }
    }

    for(int i = 0; i < v.size(); i++)
    {
        set_matrix_mem_row(v[i].second, N, i+2, x);
        set_matrix_mem_column(v[i].first, N, i+2, x);
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(x.b[i][j] > 1)
            {
                x.b[i][j] = 0;
            }
        }
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(x.b[i][j] > 0)
            {
                set_mem(i, j, a[i][j]);
            }
            else
            {
                set_mem(i, j, x.b[i][j]);
            }
        }
    }
    return true;
}
