#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n, q;
int fenw[100005];
long long t[100005];
void update_fenw(int pos)
{
    while(pos<=n)
    {
        fenw[pos]^=1;
        pos+=(pos&(-pos));
    }
}
int query_fenw(int pos)
{
    int ans=0;
    while(pos>0)
    {
        ans^=fenw[pos];
        pos-=(pos&(-pos));
    }
    return ans;
}

struct vert
{
    long long sum1, sum2, max1, max2, brdiv;
    vert() {}
    vert(long long n_1, long long n_2, long long n_3, long long n_4, long long n_5)
    {
        sum1=n_1;
        sum2=n_2;
        max1=n_3;
        max2=n_4;
        brdiv=n_5;
    }
};

bool operator==(vert p, vert q)
{
    return (p.sum1==q.sum1) && (p.sum2==q.sum2) && (p.max1==q.max1) && (p.max2==q.max2) && (p.brdiv==q.brdiv);
}

bool dvs[100005];
vert segm[400005];

vert merge_pos(vert a, vert b, bool razd)
{
    if(a==vert(-1, -1, -1, -1, -1)) return b;
    if(b==vert(-1, -1, -1, -1, -1)) return a;
    vert ans;
    ans.brdiv=a.brdiv+b.brdiv+razd;
    if(!a.brdiv && !b.brdiv)
    {
        if(razd) return vert(0, 0, a.max1, b.max2, 1);
        else return vert(0, 0, max(a.max1, b.max2), max(a.max1, b.max2), 0);
    }
    if(!a.brdiv)
    {
        if(razd) return vert(b.sum2, b.sum1+b.max1, a.max1, b.max2, ans.brdiv);
        else return vert(b.sum1, b.sum2, max(a.max2, b.max1), b.max2, ans.brdiv);
    }
    if(!b.brdiv)
    {
        if(razd)
        {
            if(a.brdiv&1) return vert(a.sum1, a.sum2+a.max2, a.max1, b.max2, ans.brdiv);
            return vert(a.sum1+a.max2, a.sum2, a.max1, b.max2, ans.brdiv);
        }
        else return vert(a.sum1, a.sum2, a.max1, max(a.max2, b.max1), ans.brdiv);
    }
    ans.max1=a.max1;
    ans.max2=b.max2;
    if(a.brdiv&1)
    {
        if(razd)
        {
            ans.sum1=a.sum1+b.max1+b.sum1;
            ans.sum2=a.sum2+a.max2+b.sum2;
        }
        else
        {
            ans.sum1=a.sum1+b.sum2;
            ans.sum2=a.sum2+b.sum1+max(a.max2, b.max1);
        }
    }
    else
    {
        if(razd)
        {
            ans.sum1=a.sum1+a.max2+b.sum2;
            ans.sum2=a.sum2+b.max1+b.sum1;
        }
        else
        {
            ans.sum1=a.sum1+max(a.max2, b.max1)+b.sum1;
            ans.sum2=a.sum2+b.sum2;
        }
    }
    return ans;
}

void update_razd(int v, int le, int ri, int pos)
{
    if(ri<=pos || le>pos) return;
    int mid=(le+ri)/2;
    update_razd(2*v, le, mid, pos);
    update_razd(2*v+1, mid+1, ri, pos);
    segm[v]=merge_pos(segm[2*v], segm[2*v+1], dvs[mid]);
}

void update_score(int v, int le, int ri, int pos)
{
    if(le==ri)
    {
        segm[v].max1=segm[v].max2=t[le];
        return;
    }
    int mid=(le+ri)/2;
    if(pos<=mid) update_score(2*v, le, mid, pos);
    else update_score(2*v+1, mid+1, ri, pos);
    segm[v]=merge_pos(segm[2*v], segm[2*v+1], dvs[mid]);
}

vert query(int v, int le, int ri, int be, int en)
{
    if(le>en || ri<be) return vert(-1, -1, -1, -1, -1);
    if(be<=le && ri<=en)
    {
        return segm[v];
    }
    int mid=(le+ri)/2;
    vert q1=query(2*v, le, mid, be, en);
    vert q2=query(2*v+1, mid+1, ri, be, en);
    return merge_pos(q1, q2, dvs[mid]);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=0; i<q; i++)
    {
        int ty;
        cin>>ty;
        if(ty==1 || ty==2)
        {
            int pos;
            cin>>pos;
            dvs[pos]^=1;
            update_fenw(pos);
            update_razd(1, 1, n, pos);
        }
        if(ty==3)
        {
            int pos;
            long long val;
            cin>>pos>>val;
            t[pos]+=val;
            update_score(1, 1, n, pos);
        }
        if(ty==4)
        {
            int be, en;
            cin>>be>>en;
            vert ans=query(1, 1, n, be, en);
            int brrazd=query_fenw(be-1);
            if(brrazd%2)
            {
                long long res=ans.max1+ans.sum1;
                if(ans.brdiv && ans.brdiv%2==0) res+=ans.max2;
                cout<<res<<endl;
            }
            else
            {
                long long res=ans.sum2;
                if(ans.brdiv%2) res+=ans.max2;
                cout<<res<<endl;
            }
        }
    }
    return 0;
}
