#include <iostream>
#include <bitset>
#include <cstring>
#include <algorithm>

#define endl '\n'

#define maxn 4005
#define maxk 25

using namespace std;

int n , k;
int red[maxn][maxn];

void read()
{
    cin >> n >> k;

    for(int i = 1; i <= k; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            cin >> red[i][j];
        }
    }
}

int used[maxk][maxn];
bitset <maxn> b1[maxn], b2[maxn];

void pre()
{
    for(int i = 1; i <= k; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            used[i][red[i][j]] = true;

            if(j == 1)
            {
                b2[red[i][j]].reset();
                b1[red[i][j]] = b1[red[i][j]] & b2[red[i][j]];
                continue;
            }

            b2[red[i][j]] = b2[red[i][j - 1]];
            b2[red[i][j]][red[i][j - 1]] = 1;

            b1[red[i][j]] = b1[red[i][j]] & b2[red[i][j]];

        }
    }
}

int dp[maxn];

void solve()
{
    memset(dp , 1 , sizeof(dp));

    for(int i = 2; i <= n; i++)
    {
        for(int j = i - 1; j > 0; j--)
        {
            if(!b1[red[0][i]][red[0][j]]) continue;
            dp[i] = max(dp[i] , dp[j] + 1);
        }
    }

    cout << *max_element(dp + 1 , dp + 1 + n) << endl;


}



int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    read();
    pre();
    solve();

    return 0;
}
