#include <iostream>
#include <algorithm>
#include <cstring>

#define endl '\n'
#define maxn 200005


using namespace std;

int n;
pair <int , int> c[maxn];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> c[i].first;
        c[i].second = i;
    }
    sort(c + 1 , c + 1 + n);
}

bool active[maxn];
int a[maxn];
int b[maxn];

void solve()
{
    memset(active , 1 , sizeof(active));

    for(int i = 1; i <= n; i++)
    {
        int cur;
        cur = (i == 1? c[i].second : c[i].second - c[i - 1].second);

        int curo = 0;
        for(int j = 1; j <= n; j++)
        {
            if(active[j] == true) curo++;
            if(curo > cur) break;
        }

        a[c[i].first] = curo;
        active[curo] = false;


    }

    for(int i = 1; i <= n; i++) cout << a[i] << " ";
    cout << endl;
    for(int i = 1; i <= n; i++) cout << c[i].second << " ";
    cout << endl;


}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    solve();

    return 0;
}
