#include<bits/stdc++.h>

using namespace std;

const int maxn = 2e6 + 10;
int n, c[maxn], a[maxn], b[maxn], f[maxn], used[maxn];
pair<int, int> p[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> c[i];
        p[i] = make_pair(c[i], i);
    }
    sort(p + 1, p + n + 1);
    for(int i = 1;i <= n;i++){
        b[p[i].second] = i;
    }
    sort(c + 1, c + n + 1);
}

void update(int idx, int val){
    for(idx = idx + 1;idx < n + 2;idx += idx & (-idx))
        f[idx] += val;
}

int query(int idx){
    if(idx == 0)
        return 0;
    int res = 0;
    for(idx = idx + 1;idx > 0;idx -= idx & (-idx))
        res += f[idx];
    return res;
}

void solve(){
    for(int i = 1;i <= n;i++)
        used[i] = 1;
    long long sum = 0;
    for(int i = 1;i <= n;i++){
        long long t = c[i] - sum, s = 0;
        for(int j = 1;j <= n;j++){
            if(s == t && used[j]){
                a[b[i]] = j;
                used[j] = 0;
                break;
            }
            s += used[j];
        }
        sum += t;
    }
    for(int i = 1;i <= n;i++)
        cout << a[i] << " ";
    cout << endl;
    for(int i = 1;i <= n;i++)
        cout << b[i] << " ";
    cout << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
