#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 5005;

int n,m;
vector<int>g[maxn];
int used[maxn];
int ind;
bool cycle;

void read()
{
    cin >> n >> m;
    int x,y;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y;
        g[x].push_back(y);
    }
}

void dfs(int beg)
{
    used[beg] = 1;
    for(int nb:g[beg])
    {
        if(used[nb]==1) cycle = true;
        if(!used[nb]) dfs(nb);
    }
    used[beg] = 2;
}

void solve()
{
    cycle = false;
    for(int i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        dfs(i);
    }
    if(cycle) cout << 0 << endl;
    else cout << 1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
