#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct Point
{
    long long ch;
    int num;
    Point(){};
    Point(long long chi, int ni)
    {
        ch = chi;
        num = ni;
    }
};

const int maxn = 2*1e6+5;
int n;
int b[maxn];
int p[maxn],a[maxn];
int tree[4*maxn];
long long c[maxn];
vector<Point>vagg;
int ql,qr;

bool cmp(Point p1, Point p2)
{
    return p1.ch<p2.ch;
}

void read()
{
    cin >> n;
    for(int i=1;i<=n;i++)
    {
        cin >> c[i];
        Point ed = {c[i],i};
        vagg.push_back(ed);
    }
    sort(vagg.begin(),vagg.end(),cmp);
    sort(c+1,c+n+1);
}

void make_tree(int v, int l, int r)
{
    if(l==r)
    {
        tree[v] = 1;
        return;
    }
    int mid = (l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+1,mid+1,r);
    tree[v] = tree[v*2+0] + tree[v*2+1];
}

int query(int v, int l, int r, int val)
{
    if(l==r) return r;
    if(tree[v]<val||l>r) return 0;
    int mid = (l+r)/2;
    int ch1 = tree[v*2+0];
    int ch2 = tree[v*2+1];
    if(ch1>=val) return query(v*2+0,l,mid+0,val);
    val -= ch1;
    return query(v*2+1,mid+1,r,val);
}

void update(int v, int l, int r)
{
    if(r<ql||qr<l||l>r) return;
    if(ql<=l&&r<=qr)
    {
        tree[v] = 0;
        return;
    }
    int mid = (l+r)/2;
    update(v*2+0,l,mid+0);
    update(v*2+1,mid+1,r);
    tree[v] = tree[v*2+0] + tree[v*2+1];
}

void solve()
{
    for(int i=0;i<vagg.size();i++)
    {
        b[vagg[i].num] = i+1;
    }
    make_tree(1,1,n);
    for(int i=0;i<vagg.size();i++)
    {
        long long br;
        if(i>0) br = vagg[i].ch - vagg[i-1].ch;
        else br = vagg[i].ch;
        br = br + 1;
        //val = br;
        int idx = query(1,1,n,br);
        p[idx] = vagg[i].num;
        ql = qr = idx;
        update(1,1,n);
        /*for(int i=1;i<=n;i++) cout << p[i] << " ";
        cout << "tova e p" << endl;*/
    }
    for(int i=1;i<=n;i++) a[p[i]] = i;
    for(int i=1;i<=n;i++) cout << a[i] << " ";
    cout << endl;
    for(int i=1;i<=n;i++) cout << b[i] << " ";
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
