#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

const int MAXN=1e6+10;

vector<pair<int,pair<int,int>>>v;
pair<int,int>seg[MAXN];
int started[2*MAXN];
int active[2*MAXN];
int ans[MAXN];
int n;

void read()
{
    cin>>n;
    for(int i=0;i<n;i++)
    {
        int a,b;
        cin>>a>>b;
        v.push_back({a,{0,i}});
        v.push_back({b,{1,i}});
    }
    sort(v.begin(),v.end());
}

void fill_seg()
{
    for(int i=0;i<2*n;i++)
    {
        int idx=v[i].second.second;
        if(v[i].second.first==0)
        {
            seg[idx].first=i;
        }
        else
        {
            seg[idx].second=i;
        }
    }
}

void fill_started()
{
    int cur=0;
    for(int i=0;i<2*n;i++)
    {
        if(v[i].second.first==0)cur++;
        started[i]=cur;
    }
}

void fill_active()
{
    int act=0;
    for(int i=0;i<2*n;i++)
    {
        active[i]=act;
        if(v[i].second.first==0)act++;
        else act--;
    }
}

void solve()
{
    read();
    fill_seg();
    fill_started();
    fill_active();
    for(int i=0;i<n;i++)
    {
        int l=seg[i].first;
        int r=seg[i].second;
        int ans=active[l]+started[r]-started[l-1]-1;
        cout<<ans<<" ";
    }
    cout<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
    return 0;
}
