#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const long long maxn = 1e5+10;

vector<long long> dif;
long long a[maxn];
long long tree[4*maxn];

void update(long long vr, long long l, long long r, long long x, long long val)
{
    if(l==r)
    {
        tree[vr]+=val;
        return;
    }
    long long mid=(l+r)>>1;
    if(x<=mid)update(2*vr,l,mid,x,val);
    else update(2*vr+1,mid+1,r,x,val);
    tree[vr]=max(tree[2*vr],tree[2*vr+1]);
}

long long query(long long vr, long long l, long long r, long long L, long long R)
{
    if(L>r||R<l)return 0;
    if(l>=L&&r<=R)return tree[vr];
    long long mid = (l+r)>>1;
    return max(query(2*vr,l,mid,L,R),query(2*vr+1,mid+1,r,L,R));
}

long long main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n,q;
    cin>>n>>q;

    for(long long i=0;i<q;i++)
    {
        long long k;
        cin>>k;
        if(k==1)
        {
            long long p;
            cin>>p;
            dif.push_back(p);
        }
        else if(k==2)
        {
            long long p;
            cin>>p;
            dif.erase(find(dif.begin(),dif.end(),p));
        }
        else if(k==3)
        {
            long long p,d;
            cin>>p>>d;
            update(1,1,n,p,d);
        }
        else if(k==4)
        {
            long long l,r;
            cin>>l>>r;
            long long ans=0;
            sort(dif.begin(),dif.end());
            long long L=0,R=dif.size()-1;
            while(L<R)
            {
                long long mid=(L+R)>>1;
                if(l<dif[mid])R=mid-1;
                else if(l>dif[mid])L=mid+1;
                else
                {
                    L=mid;
                    break;
                }
            }
            long long i;
            //cout<<L<<"*"<<endl;
            l--;
            for(i=L;i<dif.size();i++)
            {
                if(dif[i]>r)break;
                if(i%2)
                {
                    ans+=query(1,1,n,l+1,dif[i]);
                   // cout<<l<<" "<<dif[i]<<endl;
                    l=dif[i];
                }
            }
            if(i%2==1) {/*cout<<dif[i-1]+1<<" "<<r<<" "<<query(1,1,n,dif[i-1]+1,r)<<"!!";*/ans+=query(1,1,n,dif[i-1]+1,r);}
            cout<<ans<<endl;
        }
       /* for(long long i=0;i<dif.size();i++)
        {
            cout<<dif[i]<<""
        }*/
    }

    return 0;
}
/**
10 20
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 3 3
1 1
4 3 3
3 10 3
3 9 2
3 8 9
1 8
4 1 1
4 4 4
3 9 8
1 7
3 2 6
4 2 2
2 1
4 2 2

*/
