#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
}

struct point
{
    int x, y;
};

const int maxn = 2e5 + 10;

point car[maxn];

struct event
{
    int x, y1, y2;

    event(int _x = 0 , int _y1 = 0, int _y2 = 0)
    {
        x = _x;
        y1 = _y1;
        y2 = _y2;
        if (y1 > y2)
            swap(y1, y2);
        y2 --;
    }
};

bool cmp(event e1, event e2)
{
    if (e1.x != e2.x)
        return e1.x < e2.x;
    return e1.y1 < e2.y1;
}

int n, m;
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        cin >> car[i].x >> car[i].y;
}

struct interval
{
    int left, right, start;

    interval(int _left = 0, int _right = 0, int _start = 0)
    {
        left = _left;
        right = _right;
        start = _start;
    }

    bool operator < (const interval &it) const
    {
        if (left != it.left)
            return left < it.left;
        if (right != it.right)
            return right > it.right;
        return start > it.start;
    }
};

set < interval > act;
void simulate()
{
    vector < event > events;
    for (int i = 1; i < n; i ++)
    {
        if (car[i].x == car[i + 1].x)
        {
            events.push_back(event(car[i].x, car[i].y, car[i + 1].y));
        }
    }

    sort(events.begin(), events.end(), cmp);

    int ans = 0;
    bool done = false;
    int act_odd = 0, act_even = 0, last = 0;
    for (int i = 0; i < events.size() && !done; i ++)
    {

        interval cur(events[i].y1, events[i].y2, events[i].x);
        if (cur.start != last)
        {
            ///cout << cur.start << " " << last << endl;
            for (interval c : act)
                if ((c.right - c.left + 1) % 2 != 0)
                {
                    done = true;
                    break;
                }
            if (done)
                break;

            bool odd = false, even = false;
            for (interval c : act)
                if (c.start % 2 == 1)
                    odd = true;
                else
                    even = true;

            if (odd && !even)
            {
                if (cur.start % 2 == 1)
                    ans = max(ans, cur.start);
                else
                    ans = max(ans, cur.start - 1);
            }
            else
            if (!odd && even)
            {
                if (cur.start % 2 == 0)
                    ans = max(ans, cur.start);
                else
                    ans = max(ans, cur.start - 1);
            }
        }
        act.insert(cur);
        set < interval > :: iterator it = act.find(cur);

        bool add = true;
        if (it != act.begin() && prev(it) -> right >= it -> left)
            add = false;
        if (next(it) != act.end() && next(it) -> left <= it -> right)
            add = false;
        if (!add)
        {
            act.erase(cur);
            int lf = act.begin() -> left;
            int rf = act.rbegin() -> right;
            ///cout << "HERE " << lf << " " << rf << " " << cur.left << " " << cur.right << endl;
            if (lf == cur.left)
            {
                while(!act.empty())
                {
                    if (act.begin() -> right <= cur.right)
                    {
                        if ((cur.start - act.begin() -> start) % 2 != 0)
                            done = true;
                        act.erase(act.begin());
                    }
                    else
                    {
                        if ((cur.start - act.begin() -> start) % 2 != 0)
                            done = true;
                        interval new_beg = *act.begin();
                        new_beg.left = cur.right + 1;
                        act.erase(act.begin());
                        if (new_beg.left <= new_beg.right)
                            act.insert(new_beg);
                        break;
                    }
                }
            }
            else
            if (rf == cur.right)
            {
                while(!act.empty())
                {
                    if (act.rbegin() -> left >= cur.left)
                    {
                        if ((cur.start - act.rbegin() -> start) % 2 != 0)
                            done = true;
                        act.erase(*act.rbegin());
                    }
                    else
                    {
                        if ((cur.start - act.rbegin() -> start) % 2 != 0)
                            done = true;
                        interval new_beg = *act.rbegin();
                        new_beg.right = cur.left - 1;
                        act.erase(*act.rbegin());
                        if (new_beg.left <= new_beg.right)
                            act.insert(new_beg);
                        break;
                    }
                }
            }
            else
            {
                assert(false);
            }
        }
        else
        {
            if (it != act.begin())
            {
                if (prev(it) -> start == it -> start && prev(it) -> right == it -> left - 1)
                {
                    interval comb(prev(it) -> left, it -> right, cur.start);
                    act.erase(prev(it));
                    act.erase(cur);
                    act.insert(comb);
                    it = act.find(comb);
                }
            }
            if (next(it) != act.end())
            {
                if (next(it) -> start == it -> start && next(it) -> left - 1 == it -> right)
                {
                    interval comb(it -> left, next(it) -> right, cur.start);
                    act.erase(next(it));
                    act.erase(cur);
                    act.insert(comb);
                    it = act.find(comb);
                }
            }

        }

        last = cur.start;

        /**cout << "-------------" << endl;
        for (interval c : act)
            cout << c.left << " " << c.right << " " << c.start << endl;*/

    }
    cout << ans << endl;

}
void solve()
{
    input();
    simulate();
}

int main()
{
    ///speed();
    solve();
    return 0;
}

/**
14 6
0 1
0 3
2 3
2 4
0 4
0 6
3 6
3 7
4 7
6 7
6 5
3 5
3 2
3 1

*/
