#include "zeroes.h"
#include "Lgrader.cpp"

void set_matrix_mem_column(int l, int sz, int k)
{
    for(int i = 0; i < sz; i++)
        set_mem(l, i, k);
}

void set_matrix_mem_row(int l, int sz, int k)
{
    for(int i = 0; i < sz; i++)
    {
        set_mem(i, l, k);
    }
}

bool solve(int N, int call)
{
    vector<pair<int, int>> v;
    int k = 2;

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            int current = get_mem(i, j);
            if(current == 0)
            {
                v.push_back({i, j});
            }
        }
    }

    for(int i = 0; i < v.size(); i++)
    {
        k++;
        set_matrix_mem_row(v[i].second, N, k);
        set_matrix_mem_column(v[i].first, N, k);
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(get_mem(i, j) > 1)
            {
                set_mem(i, j, 0);
            }
        }
    }

    return true;
}

/*

===================
4
1 1 1 1
1 0 1 1
1 1 1 1
1 1 1 1

ANS
1 0 1 1
0 0 0 0
1 0 1 1
1 0 1 1
====================

====================
4
0 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
====================

4
1 1 1 0
1 1 1 1
1 1 1 1
1 1 1 0

===================
4
1 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
*/
