#include "zeroes.h"


void set_matrix_mem_column(int l, int sz, int k)
{
    for(int i = 0; i < sz; i++)
        set_mem(l, i, k);
}

void set_matrix_mem_row(int l, int sz, int k)
{
    for(int i = 0; i < sz; i++)
    {
        set_mem(i, l, k);
    }
}

bool solve(int N, int call)
{
    int a[1000];
    for(int i = 0; i < 1000; i++)
        a[i] = -1;

    int k = 2;

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            int current = get_mem(i, j);
            if(current == 0)
            {
                a[i] = i;
            }
        }
    }

    for(int i = 0; i < N; i++)
    {
        if(a[i] == -1) break;
        k++;
        set_matrix_mem_row(a[i], N, k);
        set_matrix_mem_column(a[i], N, k);
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(get_mem(i, j) > 1)
            {
                set_mem(i, j, 0);
            }
        }
    }

    return true;
}

/*

===================
4
1 1 1 1
1 0 1 1
1 1 1 1
1 1 1 1

ANS
1 0 1 1
0 0 0 0
1 0 1 1
1 0 1 1
====================

====================
4
0 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
====================

4
1 1 1 0
1 1 1 1
1 1 1 1
1 1 1 0

===================
4
1 1 1 1
1 1 1 1
1 1 1 1
1 1 1 1
*/
