#include "zeroes.h"
#include<vector>

#define MAGIC_CONSTANT 69420

struct danni
{
    int b[400][400];
};

void set_matrix_mem_column(int l, int sz, int k, danni& x)
{
    for(int i = 0; i < sz; i++)
        x.b[l][i] = k;
}

void set_matrix_mem_row(int l, int sz, int k, danni& x)
{
    for(int i = 0; i < sz; i++)
        x.b[i][l] = k;
}

bool solve(int N, int call)
{
    std::vector<std::pair<int, int>> v;
    int a[400][400];
    danni x;
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            a[i][j] = get_mem(i, j);
            x.b[i][j] = a[i][j];

            if(!x.b[i][j])
            {
                v.push_back({i, j});
            }
        }
    }

    for(int i = 0; i < v.size(); i++)
    {
        set_matrix_mem_row(v[i].second, N, MAGIC_CONSTANT+i, x);
        set_matrix_mem_column(v[i].first, N, MAGIC_CONSTANT+i, x);
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(x.b[i][j] >= MAGIC_CONSTANT)
            {
                x.b[i][j] = 0;
            }
        }
    }

    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            if(x.b[i][j] > 0)
            {
                set_mem(i, j, a[i][j]);
            }
            else
            {
                set_mem(i, j, x.b[i][j]);
            }
        }
    }

    /*cout << "PREMESTAVANE" << endl;
    for(int i = 0; i < N; i++, cout << endl)
    {
        for(int j = 0; j < N; j++)
        {
            cout << x.b[i][j] << ' ';
        }
    }*/
    return true;
}

/*
====================
3
1 2 3
0 4 5
6 7 0
===================
*/
