#include<bits/stdc++.h>

using namespace std;

const int maxn = 5010;
int n, m, used[maxn], a[maxn], b[maxn], price[maxn];
int matrix[maxn][maxn];
vector<int> v[maxn], g[maxn];

void read(){
    cin >> n >> m;
    for(int i = 1;i <= m;i++){
        cin >> a[i] >> b[i];
        matrix[a[i]][b[i]]++;
        v[a[i]].push_back(b[i]);
    }
}

int s, curr = maxn;

void dfs(int ver, int p = -1){
    used[ver] = 1;
    for(int nb : v[ver]){
        if(nb == p)
            continue;
        if(matrix[ver][nb])
            continue;
        if(!used[nb]){
            price[nb] = price[ver];
            matrix[ver][nb] = 1;
            matrix[nb][ver] = 1;
            dfs(nb, ver);
            matrix[ver][nb] = 0;
            matrix[nb][ver] = 0;
        }
        else if(used[nb] == 1){
            curr = min(curr, price[ver] - price[nb]);
        }
    }
    for(int nb : g[ver]){
        if(nb == p)
            continue;
        if(matrix[ver][nb])
            continue;
        if(!used[nb]){
            price[nb] = price[ver] + 1;
            matrix[ver][nb] = 1;
            matrix[nb][ver] = 1;
            dfs(nb, ver);
            matrix[nb][ver] = 0;
            matrix[ver][nb] = 0;
        }
        else if(used[nb] == 1){
            curr = min(curr, price[ver] - price[nb] + 1);
        }
    }
    used[ver] = 2;
}

bool f = false;

void DFS(int ver){
    used[ver] = 1;
    for(int nb : v[ver]){
        if(!used[nb])
            DFS(nb);
        else if(used[nb] == 1)
            f = true;
    }
    used[ver] = 2;
}

void solve(){
    for(int i = 1;i <= n;i++){
        memset(used, 0, sizeof(used));
        memset(price, 0, sizeof(price));
        dfs(i);
    }
    if(curr == maxn)
        curr = -1;
    cout << curr << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
