#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 5005;

int n,m;
vector<int>g[maxn],f[maxn];
vector<int>fr;
int used[maxn];
int ind;
bool cycle;

void read()
{
    cin >> n >> m;
    int x,y;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y;
        g[x].push_back(y);
        f[x].push_back(y);
        f[y].push_back(x);
    }
}

void dfs(int beg)
{
    used[beg] = 1;
    for(int nb:g[beg])
    {
        if(used[nb]==1) cycle = true;
        if(!used[nb]) dfs(nb);
    }
    used[beg] = 2;
}

void dfsN(int beg, int par)
{
    used[beg] = 1;
    for(int nb:f[beg])
    {
        if(nb!=par&&used[nb]==1) cycle = true;
        if(!used[nb]) dfsN(nb,beg);
    }
    used[beg] = 2;
}

void dfsF(int beg)
{
    used[beg] = 1;
    fr.push_back(beg);
    for(int nb:f[beg])
    {
        if(!used[nb]) dfsF(nb);
    }
}

void solve1()
{
    memset(used,0,sizeof(used));
    dfsF(1);
    int br = 0;
    int beg,nb2;
    bool f;
    for(int i=1;i<fr.size();i++)
    {
        beg = fr[i-1];
        nb2 = fr[i];
        f = false;
        for(int nb:g[beg]) if(nb==nb2) f = true;
        if(f) br++;
    }
    beg = fr[fr.size()-1];
    nb2 = fr[0];
    f = false;
    for(int nb:g[beg]) if(nb==nb2) f = true;
    if(f) br++;
    br = min(br,n-br);
    cout << br << endl;
    exit(0);
}

void solve3()
{

    exit(0);
}

void solve()
{
    if(n==m) solve1();
    cycle = false;
    for(int i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        dfs(i);
    }
    if(cycle)
    {
        cout << 0 << endl;
        exit(0);
    }
    cycle = false;
    for(int i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        dfsN(i,i);
    }
    if(!cycle)
    {
        cout << -1 << endl;
        exit(0);
    }
    //if(n<=500&&m<=500) solve3();
    cout << 1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
